VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdReteach 
      Caption         =   "Re-teach"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton cmdPandP 
      Caption         =   "Pick and Place"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' For accessing the robot:
Dim Robot As New CRSRobot

' For file transfer / remote execution:
Dim Controller As New CRSRemote

' From the v3 (teachables) file:
Dim locA As CRSLocation, locB As CRSLocation, locSafe As CRSLocation
Dim AppDepDist As Single        ' approach / depart distance
Dim TheSpeed As Long            ' robot speed
Dim GForce As Long              ' gripper force


Sub LoadV3Variables()
    Dim V3 As New CRSV3File
    V3.Open "test.v3", v3fCreate
    
    On Error Resume Next        ' allow the creates to fail if the vars exist
    V3.Create "a", v3tWorldLocation
    V3.Create "b", v3tWorldLocation
    V3.Create "safe", v3tWorldLocation
    V3.Create "appdepdist", v3tFloat
    V3.Create "thespeed", v3tLong
    V3.Create "gforce", v3tLong
    On Error GoTo 0             ' cancel the on error
   
    Set locA = V3.Location("a")
    Set locB = V3.Location("b")
    Set locSafe = V3.Location("safe")
    AppDepDist = V3.Value("appdepdist")
    TheSpeed = V3.Value("thespeed")
    GForce = V3.Value("gforce")
    
    V3.Close                    ' close the file
    Set V3 = Nothing
End Sub




Private Sub cmdPandP_Click()
    cmdPandP.Enabled = False

    Robot.Speed = TheSpeed
    Robot.Move locSafe
    
    ' Get the object
    Robot.GripperOpen GForce
    Robot.Approach locA, AppDepDist
    Robot.Move locA
    Robot.Finish
    Robot.GripperClose GForce
    Robot.GripperFinish
    Robot.Depart AppDepDist
    
    ' Move back to locSave
    Robot.Move locSafe
    
    ' And put the object
    Robot.Approach locB, AppDepDist
    Robot.Move locB
    Robot.Finish
    Robot.GripperOpen GForce
    Robot.GripperFinish
    Robot.Depart AppDepDist
    
    Robot.Move locSafe
    
    cmdPandP.Enabled = True
End Sub




Private Sub cmdReteach_Click()
    Dim Pid As Long, ExitPid As Long, ExitCode As Long
    cmdReteach.Enabled = False  ' prevent recursion
    
    ' First copy the file to the controller:
    Controller.PutFile "test.v3", "/app/test/test.v3", ftoOverwrite
    ' Run the pendant, and wait for it to finish:
    Robot.ControlRelease
    Controller.Run "pendant -a test", 0, Pid
    Controller.WaitForExitCode Pid, ExitPid, ExitCode, 360000
    ' Get the (modified) file back:
    Controller.GetFile "test.v3", "/app/test/test.v3", ftoOverwrite
    MsgBox "Teaching complete", vbOKOnly
    LoadV3Variables
    
    cmdReteach.Enabled = True
End Sub



Private Sub Form_Load()
    LoadV3Variables
End Sub



Private Sub Form_Unload(Cancel As Integer)
    Robot.ControlRelease
End Sub
